
#include <avr/io.h>
#include "SPI_628.h"
#include "utils628.h"



void SPI_SetSlow()
{
// SPI enabled
// master mode
// SPIclock = Fclock/64=250kHz (< 4OOkHz for Multimedia cards)
  SPCR = (1 << SPE) | (1 << MSTR) | (1 << SPR1) | (1 << SPR0);   // ATmega32.pdf p:137 
	sbi(SPSR, SPI2X);   // SPI2X=1  ATmega32.pdf p:137 
}


void SPI_SetFast()
{
// SPI enabled
// master mode
// SPIclock = Fosc/4 = 8MHz (less than 20MHz)
  SPCR = (1 << SPE) | (1 << MSTR) | (0 << SPR1) | (0 << SPR0);  // ATmega32.pdf p:137 
	sbi(SPSR, SPI2X); // ATmega32.pdf p:137 
}


uint8_t SPI_transmit(uint8_t data)
{
	SPDR = data; // Start transmission
	while(!(SPSR & (1<<SPIF))) { ; }// Wait for transmission complete
	data = SPDR;
	return(data);
}

uint8_t SPI_receive(void)
{
	unsigned char data;  // Wait for reception complete
	SPDR = 0xff;
	while(!(SPSR & (1<<SPIF)));
	data = SPDR;
	return data;
}

