#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "ui_mainwindow.h"

#include <QGraphicsView>
#include <QToolBar>
#include <QAction>
#include <QGraphicsTextItem>
#include <QGraphicsLineItem>
#include <QGraphicsItemGroup>
#include <QTimer>

#include "scene_cliquable.h"
#include "boutonled.h"
#include "qled.h"
#include "qextserialport.h"



struct Aperture
{
    char forme; // = 'R'(Rectangle) ou 'C'(Cercle) // attention :  ne pas confondre avec R comme ronde...!
    QPoint WH;
};


struct Element
{
    quint16 num_origine; // numéro d'ordre dans la liste gerber d'origine
    quint16 nouveau_num; // numéro d'ordre dans la liste gerber triée
    QString texte_affichable; // reprend les données sous forme texte pour pouvoir les afficher dans les tables
    char sorte; // = 'M' (ajout aperture) ou 'S'(segment)  ou ='P' (pastille)
    qint16 num;
    qint8 num_aperture;
    QPoint A;
    QPoint B;
    QPoint M; // milieu

    QColor couleur;
    int clique; // cliqué. = 0 ou 1
};

/*
struct Distance
{
    quint16 num_origine;
    qint16 ds; // distance à un élément donné
};
*/


//class QAction;


class MainWindow : public QMainWindow, public Ui::MainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    
    SceneCliquable *scene1;

private slots:

  //  qreal square(qreal r1);

    void lecture_fichier_init();
    void enregistrer_fichier_init();
    void effacer_ecran();
//    void effacer_pointage();
    void effacer_quadrillage();
    int lire_fichier(QString nom_fichier1);
    void tracer_circuit();
    void tracer1pas();
//    void tracer_texte(int x, int y, QString texte_i);
    int on_actionOuvrir_triggered();
    int on_actionRecharger_triggered();
    void onReceptPos_clic(int px, int py);
    void onReceptPos_survol(int px, int py);
    void onReceptPos_release(int px, int py);
 //   void mouseMoveEvent(QMouseEvent *event);
    //void mouseReleaseEvent(QMouseEvent *event);

    void on_Btn_tracer_clicked();
    void on_Btn_effacer_clicked();
    void tracer_quadrillage();
    void on_Btn_redessiner_clicked();
    void on_spinBox_posX_valueChanged(int arg1);
    void on_Btn_test_clicked();
    void on_radioButton_3_toggled(bool checked);
    void on_radioButton_1_clicked();
    void on_radioButton_2_clicked();
    void on_radioButton_5_clicked();
    void on_radioButton_8_clicked();
    void on_radioButton_9_clicked();
    void on_radioButton_4_clicked();

    void on_Btn_eff_quadrillage_clicked();

    void on_Btn_tracer_quadrillage_clicked();

    void on_spinBox_X_valueChanged(int arg1);

    void on_spinBox_Y_valueChanged(int arg1);

private:

//  QGraphicsScene *scene1;

//   QGraphicsView* view;


    void createActions();
    void createToolBar();

    QAction* lineAction;
    QAction* selectAction;
    QActionGroup *actionGroup;
    QToolBar* drawingToolBar;


    QextSerialPort *portUSB;

    QPixmap *pixmap1;

//    QGraphicsItemGroup *groupe_trace;
//    QGraphicsItemGroup *groupe_pointage;
    QGraphicsItemGroup *groupe_quadrillage;

    QGraphicsLineItem *ligne_i;
    QGraphicsRectItem *rectangle;
    QGraphicsEllipseItem *ellipse_i;
    QGraphicsTextItem *text_gradu;

    QTimer *Timer1; // pour la lecture au ralenti du fichier gerber



};

#endif // MAINWINDOW_H
